
// Share semaphore create in main.c
extern EventBlock* sem;

//
// TaskOne counts up from 0  and prints 10 lines.
//
void TaskOne(void)
{
	int count = 0;
	while(1)
	{
		// Wrap this for loop with the semaphore
		// to serialize the output

		for (int c=0; c<10; c++)
		{
			printString("--- Task One line: ");
			printUint32(c);

			printString("   Task one: ");
			for(int i=0; i<5000;i++);
			printUint32(count++);
			for(int i=0; i<5000;i++);
			printString("\n");
			for(int i=0; i<5000;i++);
		}
	}
}

//
// TaskTwo counts down from 0xFFFFFFFF and prints 10 lines.
//
void TaskTwo(void)
{
	int count = 0xFFFFFFFF;
	while(1)
	{
		// Wrap this for loop with the semaphore
		// to serialize the output

		for (int c=0; c<10; c++)
		{
			printString("    Task Two line: ");
			printUint32(c);

			printString("   count: ");
			for(int i=0; i<5000;i++);
			printUint32(count--);
			for(int i=0; i<5000;i++);
			printString("\n");
			for(int i=0; i<5000;i++);
		}
	}
}

//
// TaskThree print 10 lines
//
void TaskThree(void)
{
	while(1)
	{
		// Wrap this for loop with the semaphore
		// to serialize the output

		for (int c=0; c<10; c++)
		{
			printString("ooo Task Three line: ");
			printUint32(c);
			for(int i=0; i<5000;i++);
			printString("\n");
			for(int i=0; i<5000;i++);
		}
	}
}

//
// Small task that prints only one word each time it runs.
//
void TaskFour(void)
{
	CPU_SR cpu_sr = 0;

	while(1)
	{
		ENTER_CRITICAL();
		printString("<FOUR>");
		EXIT_CRITICAL();

		// Delay of 0 cause a context switch
		OSDelayTask(0);
	}
}

